/*
 * Created on Tue Mar 07 2023
 *
 * Copyright (C) 2023 PixelApps - All Rights Reserved
 * The code in this file is Intellectutal Property of PixelApps
 * and can't be edited, redistributed or used without a valid license of it's product (Welltested)[https://welltested.ai]
 */
import 'package:build_runner_core/build_runner_core.dart' as build_runner_core;
import 'package:welltested/builder.dart' as welltested;
import 'package:build_runner/build_runner.dart' as build_runner;
import 'package:mockito/src/builder.dart' as mockito;
import 'dart:io' as io;

final _builders = <build_runner_core.BuilderApplication>[
  build_runner_core.apply(
    r'welltested:ai',
    [welltested.welltestedGenerator],
    build_runner_core.toDependentsOf(r'welltested'),
    hideOutput: false,
  ),
  build_runner_core.apply(
    r'mockito:mockBuilder',
    [mockito.buildMocks],
    build_runner_core.toDependentsOf(r'welltested'),
    hideOutput: false,
  ),
  build_runner_core.apply(
    r'welltested:saver',
    [welltested.saverGenerator],
    build_runner_core.toDependentsOf(r'welltested'),
    hideOutput: false,
  ),
];
Future<void> main(List<String> args) async {
  build_runner_core.overrideGeneratedOutputDirectory('welltested_cache');
  final result = await build_runner.run(args, _builders);
  io.exitCode = result;
}
