/*
 * Created on Tue Mar 07 2023
 *
 * Copyright (C) 2023 PixelApps - All Rights Reserved
 * The code in this file is Intellectutal Property of PixelApps
 * and can't be edited, redistributed or used without a valid license of it's product (Welltested)[https://welltested.ai]
 */
import 'package:analyzer/dart/element/element.dart';
import 'package:source_gen/source_gen.dart';
import 'package:welltested/annotation.dart';
import 'package:welltested/src/models/widget_test_request_data.dart';
import 'package:welltested/src/repositories/generations_repository.dart';
import 'package:analyzer/dart/ast/ast.dart';
import 'package:welltested/src/repositories/path_repository.dart';
import 'package:welltested/src/visitors/class_visitor.dart';

class WidgetTestExecutor {
  final GenerationRepository _generationRepository;
  final PathRepository _pathRepository;
  WidgetTestExecutor(this._generationRepository, this._pathRepository);
  Future<WidgetTestRequestData> prepareRequest(List<AstNode> widgets,
      ClassElement element, List<ScreenType> screens) async {
    final fileImportPath =
        LibraryReader(_pathRepository.inputLibrary).pathToElement(element);
    final classVisitor = ClassVisitor();
    element.visitChildren(classVisitor);
    final widgetTestRequestData = WidgetTestRequestData(
        classType: classVisitor.className,
        fileImportPath: fileImportPath,
        widgets: widgets,
        screenTypes: screens);
    return widgetTestRequestData;
  }
}
