/*
 * Created on Tue Mar 07 2023
 *
 * Copyright (C) 2023 PixelApps - All Rights Reserved
 * The code in this file is Intellectutal Property of PixelApps
 * and can't be edited, redistributed or used without a valid license of it's product (Welltested)[https://welltested.ai]
 */
import 'package:analysis_server_lib/analysis_server_lib.dart' as serverlib;

class DartServerRepository {
  late final serverlib.AnalysisServer server;
  Future<serverlib.AnalysisServer> initialize() async {
    server = await serverlib.AnalysisServer.create();
    await server.server.onConnected.first;
    return server;
  }

  Future<String> getVersion() async {
    serverlib.VersionResult version = await server.server.getVersion();
    return version.version;
  }

  Future<void> addFilesToRoot(List<String> included,
          {List<String> excluded = const []}) async =>
      server.analysis.setAnalysisRoots(included, excluded);

  void dispose() {
    server.dispose();
  }
}
