/*
 * Created on Tue Mar 07 2023
 *
 * Copyright (C) 2023 PixelApps - All Rights Reserved
 * The code in this file is Intellectutal Property of PixelApps
 * and can't be edited, redistributed or used without a valid license of it's product (Welltested)[https://welltested.ai]
 */
import 'dart:io';

import 'package:build/build.dart';
import 'package:welltested/src/utilities/utilities.dart';

class WriterRepository {
  WriterRepository(this.buildStep);
  final BuildStep buildStep;
  Future<File> writeTestToCorrespondingFile(
      Uri importPath, String testContent, String methodName) async {
    final path = importPath.toString();

    final filePath = path.replaceFirst(path.split("/").first, "");
    return await createTestFileInDirectory(filePath, testContent, methodName);
  }

  Future<File?> getCorrespondingFile(Uri importPath, String methodName) async {
    final path = importPath.toString();

    final filePath = path.replaceFirst(path.split("/").first, "");
    return await getTestFileFromDirectory(filePath, methodName);
  }

  Future<void> outputGeneratedFile(
    AssetId assetId,
    String content,
    String functionIdentifier,
  ) async {
    await buildStep.writeAsString(
        assetId, addFunctionIdentiferAtTop(content, functionIdentifier));
  }

  String addFunctionIdentiferAtTop(String content, String functionIdentifier) {
    return content.replaceRange(0, 0, "///###$functionIdentifier###" + '\n');
  }
}
